import hiro.yoshioka.javadoc2excel.gui.Main;

import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.util.concurrent.TimeUnit;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;

import com.sun.javadoc.ClassDoc;
import com.sun.javadoc.RootDoc;

public class YonDoc {
	static JLabel label;

	public static boolean start(RootDoc root) {
		writeContents(root.classes());
		return true;
	}

	private static void writeContents(final ClassDoc[] classes) {
		JDialog dialog = new JDialog(Main.dialog, "write contents", true);
		final JProgressBar pb = new JProgressBar(0, classes.length);
		final JPanel panel = new JPanel();
		dialog.getContentPane().add(panel);
		panel.setLayout(new GridLayout(2, 1));
		pb.setValue(0);
		pb.setStringPainted(true);
		label = new JLabel("START");
		panel.add(label);
		panel.add(pb);
		dialog.setSize(400, 100);
		dialog.addWindowListener(new WindowAdapter() {
			@Override
			public void windowOpened(WindowEvent we) {
				MsgWriter obj = new MsgWriter();
				for (int i = 0; i < classes.length; i++) {
					final String theName = classes[i].name();
					final int persen = i;
					label.setText("write Contents[" + theName + "]");
					pb.setValue(persen);
					obj.doWork(classes[i]);
					panel.paintImmediately(panel.getBounds());
				}
				label.setText("generate excelfile [out.xls]");
				panel.paintImmediately(panel.getBounds());
				File outFile = new File("out.xls");
				obj.save(outFile);
				final int sum = classes.length;
				label.setText("done... see[" + outFile.getAbsolutePath() + "]");
				pb.setValue(sum);
			}
		});
		dialog.setVisible(true);

	}
}
